unit rastr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    procedure PaintBox1Paint(Sender: TObject);
  private
    procedure DrawLine(x1, y1, x2, y2: integer);
    procedure DrawCircle(x1, y1, radius: integer);
    procedure DrawSmoothCircle(x1, y1, radius, sharpcoeff: integer);
    procedure DrawSmoothCircleGamma(x1, y1, radius, sharpcoeff: integer);
    procedure DrawSmoothLine(x1, y1, x2, y2: integer);
    procedure DrawGammaSmoothLine(x1, y1, x2, y2: integer);

    {  }
  public
    {  }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const

  gamma = 2.4;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
    width, height: integer;
    rd:integer;
begin

    //  (rasterizing)
    //    

    // +  (anti-aliasing) 
    // - (gamma correction)

    PaintBox1.Canvas.Brush.Color := clBlack;
    PaintBox1.Canvas.FillRect(Rect(0, 0,
      PaintBox1.Width, PaintBox1.Height));

    rd:=200;

    //   
    while rd>5 do begin
      drawsmoothcirclegamma(paintbox1.width div 2 + 6,paintbox1.height div 2+6,rd,0);
      rd:=rd-5;
    end;

    //    
    DrawGammaSmoothLine(10,10,150,100);

end;


procedure TForm1.DrawLine(x1, y1, x2, y2: integer);
var
    canvas: TCanvas;
    i, v, u, b, a, d, t, e, color1, color2, w: integer;
begin

    canvas := PaintBox1.Canvas;

    if (x1 > x2) then begin
        t := x2;
        x2 := x1;
        x1 := t;
    end;

    if (y1 > y2) then begin
        t := y2;
        y2 := y1;
        y1 := t;
    end;

    u := x2 - x1;
    v := y2 - y1;
    e := 0;


    if (v >= u) then begin
        d := 2 * u - v;

        for i := 0 to v do begin

            //color1 := (clwhite * e) div (2 * u);
            //color2 := clwhite - color1;

            //canvas.Pixels[x1, y1] := color1;
            //canvas.Pixels[x1, y1 + 1] := color2;

            if (d < 0) then begin
                inc(y1);
                d := d + 2 * u;
                e := e + 2 * u;
            end else begin
                inc(y1);
                inc(x1);
                d := d + 2 * u - 2 * v;
                e := e + 2 * u - 2 * v;
            end;

        end;

    end else begin
        d := 2 * v - u;

        for i := 0 to u do begin

            w := (255 * e) div (2 * u);
            canvas.Pixels[x1, y1] := clwhite;

            if (d < 0) then begin
                inc(x1);
                d := d + 2 * v;
                e := e + 2 * v;
            end else begin
                inc(x1);
                inc(y1);
                d := d + 2 * v - 2 * u;
                e := e + 2 * v - 2 * u;
            end;
        end;
    end;

end;

procedure TForm1.DrawSmoothLine(x1, y1, x2, y2: integer);

var
    canvas: TCanvas;
    i, v, u, b, a, d, t, e, color1, color2, w: integer;
begin

    canvas := PaintBox1.Canvas;

    if (x1 > x2) then begin
        t := x2;
        x2 := x1;
        x1 := t;
    end;

    if (y1 > y2) then begin
        t := y2;
        y2 := y1;
        y1 := t;
    end;

    u := x2 - x1;
    v := y2 - y1;
    e := 0;


    if (v >= u) then begin
        d := 2 * u - v;

        for i := 0 to v do begin

            w := (255 * abs(e)) div (2 * v);
            b := (255 * (2 * v - abs(e))) div (2 * v);

            color1 := w shl 16 + w shl 8 + w;
            color2 := b shl 16 + b shl 8 + b;

            canvas.Pixels[x1, y1] := color2;

            if (e <= 0) then begin
                canvas.Pixels[x1, y1 - 1] := color1;
            end else begin
                canvas.Pixels[x1, y1 + 1] := color1;
            end;


            if (d < 0) then begin
                inc(y1);
                d := d + 2 * u;
                e := e + 2 * u;
            end else begin
                inc(y1);
                inc(x1);
                d := d + 2 * u - 2 * v;
                e := e + 2 * u - 2 * v;
            end;

        end;

    end else begin
        d := 2 * v - u;

        for i := 0 to u do begin

            w := (255 * abs(e)) div (2 * u);
            b := (255 * (2 * u - abs(e))) div (2 * u);

            color1 := w shl 16 + w shl 8 + w;
            color2 := b shl 16 + b shl 8 + b;

            canvas.Pixels[x1, y1] := color2;

            if (e <= 0) then begin
                canvas.Pixels[x1-1, y1] := color1;
            end else begin
                canvas.Pixels[x1+1, y1] := color1;
            end;

            if (d < 0) then begin
                inc(x1);
                d := d + 2 * v;
                e := e + 2 * v;
            end else begin
                inc(x1);
                inc(y1);
                d := d + 2 * v - 2 * u;
                e := e + 2 * v - 2 * u;
            end;
        end;
    end;
end;

procedure TForm1.DrawGammaSmoothLine(x1, y1, x2, y2: integer);

var
    canvas: TCanvas;
    i, v, u, b, a, d, t, e, color1, color2, w, mw, mb: integer;
begin

    canvas := PaintBox1.Canvas;

    if (x1 > x2) then begin
        t := x2;
        x2 := x1;
        x1 := t;
    end;

    if (y1 > y2) then begin
        t := y2;
        y2 := y1;
        y1 := t;
    end;

    u := x2 - x1;
    v := y2 - y1;
    e := 0;


    if (v >= u) then begin
        d := 2 * u - v;

        for i := 0 to v do begin

            w := (255 * abs(e)) div (2 * v);
            b := (255 * (2 * v - abs(e))) div (2 * v);

            if (w > 0) then begin
                mw := round(255 * exp( ln(w / 255) / gamma));
            end else begin
                mw := 0;
            end;

            if (b > 0) then begin
                mb := round(255 * exp( ln (b / 255) / gamma));
            end else begin
                mb := 0;
            end;

            color1 := mw shl 16 + mw shl 8 + mw;
            color2 := mb shl 16 + mb shl 8 + mb;

            color1 := mw shl 16 + mw shl 8 + mw;
            color2 := mb shl 16 + mb shl 8 + mb;

            canvas.Pixels[x1, y1] := color2;

            if (e <= 0) then begin
                canvas.Pixels[x1 - 1, y1] := color1;
            end else begin
                canvas.Pixels[x1 + 1, y1] := color1;
            end;


            if (d < 0) then begin
                inc(y1);
                d := d + 2 * u;
                e := e + 2 * u;
            end else begin
                inc(y1);
                inc(x1);
                d := d + 2 * u - 2 * v;
                e := e + 2 * u - 2 * v;
            end;

        end;

    end else begin
        d := 2 * v - u;

        for i := 0 to u do begin

            w := (255 * abs(e)) div (2 * u);
            b := (255 * (2 * u - abs(e))) div (2 * u);

            if (w > 0) then begin
                mw := round(255 * exp( ln(w / 255) / gamma));
            end else begin
                mw := 0;
            end;

            if (b > 0) then begin
                mb := round(255 * exp( ln (b / 255) / gamma));
            end else begin
                mb := 0;
            end;

            color1 := mw shl 16 + mw shl 8 + mw;
            color2 := mb shl 16 + mb shl 8 + mb;

            canvas.Pixels[x1, y1] := color2;

            if (e <= 0) then begin
                canvas.Pixels[x1, y1 - 1] := color1;
            end else begin
                canvas.Pixels[x1, y1 + 1] := color1;
            end;

            if (d < 0) then begin
                inc(x1);
                d := d + 2 * v;
                e := e + 2 * v;
            end else begin
                inc(x1);
                inc(y1);
                d := d + 2 * v - 2 * u;
                e := e + 2 * v - 2 * u;
            end;
        end;
    end;
end;


procedure TForm1.DrawCircle(x1, y1, radius: integer);
var
    d, u, v, x, y: integer;
begin

    d := 3 - 2 * radius;
    u := 0;
    v := 0;
    x := 0;
    y := radius;

    while (v < 10) do begin


        paintbox1.canvas.Pixels[x + x1, y + y1] := clwhite;
        paintbox1.canvas.Pixels[-x + x1, y + y1] := clwhite;
        paintbox1.canvas.Pixels[x + x1, -y + y1] := clwhite;
        paintbox1.canvas.Pixels[-x + x1, -y + y1] := clwhite;
        paintbox1.canvas.Pixels[y + x1, x + y1] := clwhite;
        paintbox1.canvas.Pixels[-y + x1, x + y1] := clwhite;
        paintbox1.canvas.Pixels[y + x1, -x + y1] := clwhite;
        paintbox1.canvas.Pixels[-y + x1, -x + y1] := clwhite;


        if (d <= 0) then begin


            u := 4 * x + 6;
            x := x + 1;

            d := d + u;
            //d := d + v;
            //u := u + 4;
            //v := v + 8;

        end else begin
            v := 4 * (x - y) + 10;
            x := x + 1;
            y := y - 1;

            d := d + v;
            //d := d + u;
            //u := u + 4;
            //v := v + 4;

        end;
    end;


end;

procedure TForm1.DrawSmoothCircle(x1, y1, radius, sharpcoeff: integer);
var
    d, u, v, x, y, e, w, b: integer;
    color1,color2:TColor;
begin

    d := 3 - 2 * radius;
    x := 0;
    e := 0;
    y := radius;
    u := 4 * x + 6;
    v := 4 * (x - y) + 10;

    while (v < 10) do begin

        w := (255 * abs(d)) div (4 * (sharpcoeff+1) * radius + e + 1);
        b := 255 - w;

        color1 := w shl 16 + w shl 8 + w;
        color2 := b shl 16 + b shl 8 + b;

        paintbox1.canvas.Pixels[x + x1, y + y1] := color2;


        paintbox1.canvas.Pixels[x + x1, -y + y1] := color2;
        paintbox1.canvas.Pixels[-x + x1, y + y1] := color2;
        paintbox1.canvas.Pixels[-x + x1, -y + y1] := color2;

        paintbox1.canvas.Pixels[y + x1, x + y1] := color2;
        paintbox1.canvas.Pixels[y + x1, -x + y1] := color2;
        paintbox1.canvas.Pixels[-y + x1, x + y1] := color2;
        paintbox1.canvas.Pixels[-y + x1, -x + y1] := color2;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[x + x1, y + y1 + 1] := color1;
        end else begin
             paintbox1.canvas.Pixels[x + x1, y + y1 - 1] := color1;
        end;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[-x + x1, y + y1 + 1] := color1;
        end else begin
             paintbox1.canvas.Pixels[-x + x1, y + y1 - 1] := color1;
        end;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[x + x1, -y + y1 - 1] := color1;
        end else begin
             paintbox1.canvas.Pixels[x + x1, -y + y1 + 1] := color1;
        end;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[-x + x1, -y + y1 - 1] := color1;
        end else begin
             paintbox1.canvas.Pixels[-x + x1, -y + y1 + 1] := color1;
        end;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[y + x1 + 1, x + y1] := color1;
        end else begin
             paintbox1.canvas.Pixels[y + x1 - 1, x + y1] := color1;
        end;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[-y + x1 - 1, x + y1] := color1;
        end else begin
             paintbox1.canvas.Pixels[-y + x1 + 1, x + y1] := color1;
        end;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[y + x1 + 1, -x + y1] := color1;
        end else begin
             paintbox1.canvas.Pixels[y + x1 - 1, -x + y1] := color1;
        end;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[-y + x1 - 1, -x + y1] := color1;
        end else begin
             paintbox1.canvas.Pixels[-y + x1 + 1, -x + y1] := color1;
        end;

        if (d < 0) then begin
            u := 4 * x + 6;
            x := x + 1;

            d := d + u;

        end else begin
            v := 4 * (x - y) + 10;
            x := x + 1;
            y := y - 1;

            d := d + v;
        end;
    end;

end;

procedure TForm1.DrawSmoothCircleGamma(x1, y1, radius, sharpcoeff: integer);
var
    d, u, v, x, y, e, w, b: integer;
    mw,mb: integer;
    color1,color2:TColor;
begin

    d := 3 - 2 * radius;
    x := 0;
    e := 0;
    y := radius;
    u := 4 * x + 6;
    v := 4 * (x - y) + 10;

    while (v < 10) do begin

        //      , 
        //  -  ( = 0)
        //  -     

        w := (255 * abs(d)) div (4 * (sharpcoeff+1) * radius + e + 1);
        b := 255 - w;

        if (w > 0) then begin
            mw := round(255 * exp( ln(w / 255) / gamma));
        end else begin
            mw := 0;
        end;

        if (b > 0) then begin
            mb := round(255 * exp( ln (b / 255) / gamma));
        end else begin
            mb := 0;
        end;

        color1 := mw shl 16 + mw shl 8 + mw;
        color2 := mb shl 16 + mb shl 8 + mb;

        paintbox1.canvas.Pixels[x + x1, y + y1] := color2;


        paintbox1.canvas.Pixels[x + x1, -y + y1] := color2;
        paintbox1.canvas.Pixels[-x + x1, y + y1] := color2;
        paintbox1.canvas.Pixels[-x + x1, -y + y1] := color2;

        paintbox1.canvas.Pixels[y + x1, x + y1] := color2;
        paintbox1.canvas.Pixels[y + x1, -x + y1] := color2;
        paintbox1.canvas.Pixels[-y + x1, x + y1] := color2;
        paintbox1.canvas.Pixels[-y + x1, -x + y1] := color2;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[x + x1, y + y1 + 1] := color1;
        end else begin
             paintbox1.canvas.Pixels[x + x1, y + y1 - 1] := color1;
        end;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[-x + x1, y + y1 + 1] := color1;
        end else begin
             paintbox1.canvas.Pixels[-x + x1, y + y1 - 1] := color1;
        end;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[x + x1, -y + y1 - 1] := color1;
        end else begin
             paintbox1.canvas.Pixels[x + x1, -y + y1 + 1] := color1;
        end;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[-x + x1, -y + y1 - 1] := color1;
        end else begin
             paintbox1.canvas.Pixels[-x + x1, -y + y1 + 1] := color1;
        end;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[y + x1 + 1, x + y1] := color1;
        end else begin
             paintbox1.canvas.Pixels[y + x1 - 1, x + y1] := color1;
        end;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[-y + x1 - 1, x + y1] := color1;
        end else begin
             paintbox1.canvas.Pixels[-y + x1 + 1, x + y1] := color1;
        end;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[y + x1 + 1, -x + y1] := color1;
        end else begin
             paintbox1.canvas.Pixels[y + x1 - 1, -x + y1] := color1;
        end;

        if (d <= 0) then begin
             paintbox1.canvas.Pixels[-y + x1 - 1, -x + y1] := color1;
        end else begin
             paintbox1.canvas.Pixels[-y + x1 + 1, -x + y1] := color1;
        end;

        if (d < 0) then begin
            u := 4 * x + 6;
            x := x + 1;

            d := d + u;

        end else begin
            v := 4 * (x - y) + 10;
            x := x + 1;
            y := y - 1;

            d := d + v;
        end;
    end;

end;

end.
